package gov.nasa.gsfc.dqss.gui;


import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.transform.TransformerException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import gov.nasa.gsfc.gesdisc.ontology.OntologyModel;
import gov.nasa.gsfc.gesdisc.ontology.QueryOntology;
import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.helpers.Loader;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;


public class SparqlResult extends HttpServlet {
  private OntologyModel om = null;
  private static Logger logger = Logger.getLogger(SparqlResult.class);
  private  String parontology=null;
  private  String ontology = null;
  

  public void init()
    throws ServletException
  {
    
    parontology = getServletConfig().getInitParameter("PAR_ONTOLOGY");
//    ontology = getServletConfig().getInitParameter("ONTOLOGY");
  //  URL url = Loader.getResource("log4j.properties");
  //  PropertyConfigurator.configure(url);
            logger.info("initiating servlet...");
     
    om = new OntologyModel();
    om.setOntologyUrls(parontology);
 //   om.setOntologyUrls(ontology);
    om.readOntology();
  }

  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
    throws ServletException, IOException
  {
    PrintWriter out = response.getWriter();
    DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
    domFactory.setNamespaceAware(true); // never forget this!
	    DocumentBuilder builder = null;
		try {
			builder = domFactory.newDocumentBuilder();
	                Document doc = builder.parse("cfg/DQSSNavigation.xml");
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		 catch (SAXException se) {
			// TODO Auto-generated catch block
			se.printStackTrace();
		}
		 catch (IOException ioe) {
			// TODO Auto-generated catch block
			ioe.printStackTrace();
		}

     
     String prefix=   "PREFIX dqss: <http://mirador.gsfc.nasa.gov/ontologies/dqss1.owl#> " +
               "PREFIX owl: <http://www.w3.org/2002/07/owl#> " +
               "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> " +
               "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> " +
               "PREFIX dc: <http://purl.org/dc/elements/1.1/> " + 
               "PREFIX dqssinstances: <http://org.esipfed.dataquality/dqss-instances#> "; 
   
     
  
    String dataset = request.getParameter("query");
    String reload = request.getParameter("reload");
    if (dataset != null)
    {
    response.setContentType("text/xml;charset=utf-8");

 
     String query=prefix + "SELECT  ?dg ?dv ?validqt ?order " +
         " WHERE { ?Dataset dc:title \"" + dataset + "\" . " +
         "?QView rdf:type dqss:QualityView . " +
         "?QView dc:title  ?QualityView . " +
         "?QView dqss:hasDataVariable ?dv . " +
         "?QView dqss:hasDataGroup ?dg . " +
         "?QView dqss:isValidForDataset ?Dataset ." +
         "?dg dqss:hasOrder ?order. " +
         "?dv dc:title ?dtitle . " +
         "?QView dqss:hasScreeningVariable ?dql . " +
         "?dql dc:title ?qtitle . " +
         "?dql dqss:hasValidQualityLevel ?validqt . " + 
         " } ";
     
    logger.info(query);
    QueryOntology qo = new QueryOntology();
    qo.setModel(om);
    qo.setQueryStatement(query);
    try
    {
    String xmlString = qo.getQueryResult();
    out.println(xmlString);
    } 
    catch (TransformerException e)
    {
     out.println(
     "Got an XML transformation errors: " + e.getMessage());
    }
   }
   if (reload != null)
   {
    out.println("Reloading Ontology");
    om = new OntologyModel();
    om.setOntologyUrls(parontology);
    om.setOntologyUrls(ontology);
    om.readOntology();
   }
  }
  
  public void destroy()
  {
	  logger.info("destroying");
  }
}

