package gov.nasa.gsfc.dqss.test;

import gov.nasa.gsfc.dqss.DataFile;
import gov.nasa.gsfc.dqss.MaskFactory;
import gov.nasa.gsfc.dqss.Masker;
import gov.nasa.gsfc.dqss.Statistics;
import ncsa.hdf.object.Dataset;

public class CH4_2D extends MaskFactory {
	
	
	 public CH4_2D(String criteria, String parameter, long rows, long cols, long layers) {
		 super(criteria, parameter, rows, cols, layers);
	 }
	 
	   
	  public  void doThisMask(Dataset dv, Dataset[] qs) throws  Exception  {
		    
	    	/*
	    	 * Ok, what I am going to do here is to read in TAirStd and nBestStd.
	    	 * The Dataset.read() method should read nBestStd in as one array. 
	    	 * Whether it is in 2D or not I don't care as long as it reads in each
	    	 * TAirStd Layer in the same manner.
	    	 * So I will read the first layer.
	    	 * For every qs[i] if the layer number < qs[i] I'll set it to 0 otherwise
	    	 * I'll set it to 1. 
	    	 */
	    	Dataset dqs = qs[0];
	    	
	   
	    	short[] quality = (short[]) dqs.read();
	    	float fill = (float) DataFile.getFillValue(dv);
	    
	    	Masker.ReportError ("length:" + quality.length,2);
	    	float before;
    		float[] data = (float[]) dv.read();
	    	
	    	int i;
	    		for ( i = 0; i < rows * cols; ++i) {
	    			before = data[i];
	    			if (quality[i] <= pCrit) {	    		
	    				data[i] = 1;
	    		
	    			}
	    			else {
	    				data[i] = fill;
	    				stats.inc();
	    			}
	    		    if (i % 100 == 0) {
	    		    	Masker.ReportError(" quality:" + quality[i] +
	    					" Therefore:" + data[i] + " before:" + before,2);
	    		    }
	    		}
	    		dv.write(data);
	    		stats.setTotal(i);
	    		
	    		
	    	
	    	
	    }
}
