package gov.nasa.gsfc.dqss.test;

import gov.nasa.gsfc.dqss.DataFile;
import gov.nasa.gsfc.dqss.MaskFactory;
import gov.nasa.gsfc.dqss.Masker;
import gov.nasa.gsfc.dqss.Statistics;
import ncsa.hdf.object.Dataset;

public class TAirStd_3D extends Mask{

	 int indexoffset = 1;
	 
	 
	  public TAirStd_3D() {
		  /*
		   * The layer number in the SDS nBestStd is the lowest altitude 
		   * layer for which the quality is Best.
		   * if datalayer >= qualitypixel[i] set data[i] = 1, else fillvalue  
		   */
		  stats = new Statistics();
	  }
	  public  void doThisMask(Dataset dtairstd, Dataset[] qs) {
		    
	    	/*
	    	 * Ok, what I am going to do here is to read in TAirStd and nBestStd.
	    	 * The Dataset.read() method should read nBestStd in as one array. 
	    	 * Whether it is in 2D or not I don't care as long as it reads in each
	    	 * TAirStd Layer in the same manner.
	    	 * So I will read the first layer.
	    	 * For every qs[i] if the layer number < qs[i] I'll set it to 0 otherwise
	    	 * I'll set it to 1. 
	    	 */
	    	Dataset dqs = qs[0];
	    	
	    	try {
	    		
				Dim3SingleQS(dtairstd,dqs,3,45,30,28);
				//displayValues(45,30,28,dtairstd);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
	    }
	  
	  private void Dim3SingleQS(Dataset parameter, Dataset qs, int rank,int rows, int cols, int layers ) throws Exception
	    {
	    	short[] quality = (short[]) qs.getData();
	    	long[] start = parameter.getStartDims(); // get startDims so we can navigate the layers
	    	long nlayer = start[2];
	    	float fill = (float) DataFile.getFillValue(parameter);
	    	
	    	Masker.ReportError ("length:" + quality.length,2);
	    	float before;
	    	for (int layer = 0 ; layer < layers; ++layer) {
	    		start[2] = layer; // this sets the layer outside the class as dims are passed by reference.
	    		float[] data = (float[]) parameter.read();
	    		
	    		for (int i = 0; i < rows * cols; ++i) {
	    			 before = data[i];
	    			if (layer + indexoffset >= quality[i]) {
	    		
	    				data[i] = 1;
	    				stats.inc();
	    			}
	    			else {
	    				data[i] = fill;
	    			}
	    		    if (i % 200 == 0) {
	    		    	Masker.ReportError("layer:"+layer + " quality:" + quality[i] +
	    					" Therefore:" + data[i] + " before:" + before,2);
	    		    }
	    		}
	    		parameter.write(data);
	    		
	    	}
	    	stats.setTotal(layers * rows * cols);
	    	
	    }
}
